/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package common.timer;

import common.timer.ejb.TimerSvcImpl;
import java.io.Serializable;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author riccardo
 */
public class CommandTimerTask extends java.util.TimerTask {

    public CommandTimerTask(TimerTaskCommand taskCommand) {
        this.taskCommand = taskCommand;
    }
    private TimerTaskCommand taskCommand;

    @Override
    public void run() {
        TimerTask task = null;
        Logger.getLogger(this.getClass().getSimpleName()).log(Level.INFO, "TimerTaskCommand scheduled execution : " + taskCommand.toString());
        try {
            Serializable taskData = taskCommand.getPayload();
            Class taskClass = taskCommand.getTaskExecutorClass();
            task = TimerTask.buildTask(taskClass, taskData);
            task.execute();
        } catch (Exception ex) {
            Logger.getLogger(this.getClass().getSimpleName()).log(Level.SEVERE, "Exception in TimerTask execution: " + ex, ex);
        }
        if (task != null) {
            TimerTaskCommand nextCommand = task.getNextCommand(taskCommand);
            Logger.getLogger(this.getClass().getSimpleName()).log(Level.INFO, "Task re-scheduling : " + nextCommand.toString());
            if (nextCommand != null) {
                TimerSvcImpl.getInstance().scheduleTaskCommand(nextCommand);
            }
        }
    }
    
}
