/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package common.timer.ejb;

import common.timer.CommandTimerTask;
import common.timer.TimerTask;
import common.timer.TimerTaskCommand;
import java.util.Timer;
import java.util.UUID;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author mauro
 */
public class TimerSvcImpl implements TimerSvc {

    private final long SECONDS = 1000L;
    private final String LOGGER_NAME = "TimerSvc";

// ---------------------------------------------------------------------------

    @Override
    public Timer scheduleTask(TimerTask task) {
        Timer t = scheduleTaskCommand(task.getFirstCommand());

        if( t != null ) {
            return t;
        }

        return null;
    }

//    public void onTaskTimer(Timer timer) {
//        TimerTaskCommand taskCommand = (TimerTaskCommand) timer.getInfo();
//        TimerTask task = null;
//
//        Logger.getLogger(LOGGER_NAME).log(Level.INFO, "TimerTaskCommand scheduled execution : "+taskCommand.toString());
//        try {
//            Serializable taskData = taskCommand.getPayload();
//            Class taskClass = taskCommand.getTaskExecutorClass();
//            task = TimerTask.buildTask(taskClass, taskData);
//            task.execute();
//        } catch (Exception ex) {
//            Logger.getLogger(LOGGER_NAME).log(Level.SEVERE, "Exception in TimerTask execution: "+ex, ex);
//        }
//
//        if (task != null) {
//            TimerTaskCommand nextCommand = task.getNextCommand(taskCommand);
//        Logger.getLogger(LOGGER_NAME).log(Level.INFO, "Task re-scheduling : "+nextCommand.toString());
//            if( nextCommand != null ) {
//                this.scheduleTaskCommand(nextCommand);
//            }
//        }
//    }

// ---------------------------------------------------------------------------

    public Timer scheduleTaskCommand(TimerTaskCommand taskCommand) {
        
        Timer timer = new Timer(taskCommand.getClass().getSimpleName() + "_" + UUID.randomUUID());
        timer.schedule(new CommandTimerTask(taskCommand), taskCommand.getSleepSecsBefore() * SECONDS);
        
        Logger.getLogger(LOGGER_NAME).log(Level.FINE, "TimerTaskCommand scheduled: "+taskCommand.toString());

        return timer;
    }
    
    //////////////////////////////////////
    private static TimerSvcImpl instance = new TimerSvcImpl();
    private TimerSvcImpl() {
    }

    public static TimerSvcImpl getInstance() {
        return instance;
    }

}
